LIBRARY ieee; 
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY gene_cosinus IS
PORT( 
	H	: IN std_logic;
	Read: IN std_logic;
	A	: IN std_logic_vector(7 downto 0);
	D	: OUT std_logic_vector(15 downto 0));
END gene_cosinus ;
ARCHITECTURE comport OF gene_cosinus IS
	TYPE ROM_Array IS ARRAY (0 to 255) of std_logic_vector(15 downto 0);

	constant Contenu: ROM_Array := (
	0 => x"3ffa" ,
	1 => x"3fff" ,
	2 => x"3ffa" ,
	3 => x"3feb" ,
	4 => x"3fd2" ,
	5 => x"3fb0" ,
	6 => x"3f83" ,
	7 => x"3f4d" ,
	8 => x"3f0d" ,
	9 => x"3ec4" ,
	10 => x"3e70" ,
	11 => x"3e14" ,
	12 => x"3dad" ,
	13 => x"3d3d" ,
	14 => x"3cc4" ,
	15 => x"3c41" ,
	16 => x"3bb5" ,
	17 => x"3b1f" ,
	18 => x"3a81" ,
	19 => x"39da",
	20 => x"3929" ,
	21 => x"3870" ,
	22 => x"37ae" ,
	23 => x"36e4" ,
	24 => x"3611" ,
	25 => x"3535" ,
	26 => x"3452" ,
	27 => x"3366" ,
	28 => x"3273" ,
	29 => x"3178" ,
	30 => x"3075" ,
	31 => x"2f6b" ,
	32 => x"2e59" ,
	33 => x"2d40" ,
	34 => x"2c20" ,
	35 => x"2afa" ,
	36 => x"29cc" ,
	37 => x"2899" ,
	38 => x"275f" ,
	39 => x"261f" ,
	40 => x"24d9" ,
	41 => x"238d" ,
	42 => x"223c" ,
	43 => x"20e6" ,
	44 => x"1f8b" ,
	45 => x"1e2a" ,
	46 => x"1cc5" ,
	47 => x"1b5c" ,
	48 => x"19ef" ,
	49 => x"187d" ,
	50 => x"1708" ,
	51 => x"158f" ,
	52 => x"1413" ,
	53 => x"1293" ,
	54 => x"1111" ,
	55 => x"0f8c" ,
	56 => x"0e05" ,
	57 => x"0c7c" ,
	58 => x"0af0" ,
	59 => x"0963" ,
	60 => x"07d5",
	61 => x"0645" ,
	62 => x"04b5" ,
	63 => x"0323" ,
	64 => x"0192" ,
	65 => x"0000" ,
	66 => x"fe6e" ,
	67 => x"fcdd" ,
	68 => x"fb4b" ,
	69 => x"f9bb" ,
	70 => x"f82b" ,
	71 => x"f69d" ,
	72 => x"f510" ,
	73 => x"f384" ,
	74 => x"f1fb" ,
	75 => x"f074" ,
	76 => x"eeef" ,
	77 => x"ed6d" ,
	78 => x"ebed" ,
	79 => x"ea71" ,
	80 => x"e8f8" ,
	81 => x"e783" ,
	82 => x"e611" ,
	83 => x"e4a4" ,
	84 => x"e33b" ,
	85 => x"e1d6" ,
	86 => x"e075" ,
	87 => x"df1a" ,
	88 => x"ddc4" ,
	89 => x"dc73" ,
	90 => x"db27" ,
	91 => x"d9e1" ,
	92 => x"d8a1" ,
	93 => x"d767" ,
	94 => x"d634" ,
	95 => x"d506" ,
	96 => x"d3e0" ,
	97 => x"d2c0" ,
	98 => x"d1a7" ,
	99 => x"d095" ,
	100 => x"cf8b" ,
	101 => x"ce88" ,
	102 => x"cd8d" ,
	103 => x"cc9a" ,
	104 => x"cbae" ,
	105 => x"cacb" ,
	106 => x"c9ef" ,
	107 => x"c91c" ,
	108 => x"c852" ,
	109 => x"c790" ,
	110 => x"c6d7" ,
	111 => x"c626" ,
	112 => x"c57f" ,
	113 => x"c4e1" ,
	114 => x"c44b" ,
	115 => x"c3bf" ,
	116 => x"c33c" ,
	117 => x"c2c3" ,
	118 => x"c253" ,
	119 => x"c1ec" ,
	120 => x"c190" ,
	121 => x"c13c" ,
	122 => x"c0f3" ,
	123 => x"c0b3" ,
	124 => x"c07d" ,
	125 => x"c050" ,
	126 => x"c02e" ,
	127 => x"c015" ,
	128 => x"c006" ,
	129 => x"c001" ,
	130 => x"c006" ,
	131 => x"c015" ,
	132 => x"c02e" ,
	133 => x"c050" ,
	134 => x"c07d" ,
	135 => x"c0b3" ,
	136 => x"c0f3" ,
	137 => x"c13c" ,
	138 => x"c190" ,
	139 => x"c1ec" ,
	140 => x"c253" ,
	141 => x"c2c3" ,
	142 => x"c33c" ,
	143 => x"c3bf" ,
	144 => x"c44b" ,
	145 => x"c4e1" ,
	146 => x"c57f" ,
	147 => x"c626" ,
	148 => x"c6d7" ,
	149 => x"c790" ,
	150 => x"c852" ,
	151 => x"c91c" ,
	152 => x"c9ef" ,
	153 => x"cacb" ,
	154 => x"cbae" ,
	155 => x"cc9a" ,
	156 => x"cd8d" ,
	157 => x"ce88" ,
	158 => x"cf8b" ,
	159 => x"d095" ,
	160 => x"d1a7" ,
	161 => x"d2c0" ,
	162 => x"d3e0" ,
	163 => x"d506" ,
	164 => x"d634" ,
	165 => x"d767" ,
	166 => x"d8a1" ,
	167 => x"d9e1" ,
	168 => x"db27" ,
	169 => x"dc73" ,
	170 => x"ddc4" ,
	171 => x"df1a" ,
	172 => x"e075" ,
	173 => x"e1d6" ,
	174 => x"e33b" ,
	175 => x"e4a4" ,
	176 => x"e611" ,
	177 => x"e783" ,
	178 => x"e8f8" ,
	179 => x"ea71" ,
	180 => x"ebed" ,
	181 => x"ed6d" ,
	182 => x"eeef" ,
	183 => x"f074" ,
	184 => x"f1fb" ,
	185 => x"f384" ,
	186 => x"f510" ,
	187 => x"f69d" ,
	188 => x"f82b" ,
	189 => x"f9bb" ,
	190 => x"fb4b" ,
	191 => x"fcdd" ,
	192 => x"fe6e" ,
	193 => x"0000" ,	   
	194 => x"0192" ,
	195 => x"0323" ,
	196 => x"04b5" ,
	197 => x"0645" ,
	198 => x"07d5" ,
	199 => x"0963" ,
	200 => x"0af0" ,
	201 => x"0c7c" ,
	202 => x"0e05" ,
	203 => x"0f8c" ,
	204 => x"1111" ,
	205 => x"1293" ,
	206 => x"1413" ,
	207 => x"158f" ,
	208 => x"1708" ,
	209 => x"187d" ,
	210 => x"19ef" ,
	211 => x"1b5c" ,
	212 => x"1cc5" ,
	213 => x"1e2a" ,
	214 => x"1f8b" ,
	215 => x"20e6" ,
	216 => x"223c" ,
	217 => x"238d" ,
	218 => x"24d9" ,
	219 => x"261f" ,
	220 => x"275f" ,
	221 => x"2899" ,
	222 => x"29cc" ,
	223 => x"2afa" ,
	224 => x"2c20" ,
	225 => x"2d40" ,
	226 => x"2e59" ,
	227 => x"2f6b" ,
	228 => x"3075" ,
	229 => x"3178" ,
	230 => x"3273" ,
	231 => x"3366" ,
	232 => x"3452" ,
	233 => x"3535" ,
	234 => x"3611" ,
	235 => x"36e4" ,
	236 => x"37ae" ,
	237 => x"3870" ,
	238 => x"3929" ,
	239 => x"39da" ,
	240 => x"3a81" ,
	241 => x"3b1f" ,
	242 => x"3bb5" ,
	243 => x"3c41" ,
	244 => x"3cc4" ,
	245 => x"3d3d" ,
	246 => x"3dad" ,
	247 => x"3e14" ,
	248 => x"3e70" ,
	249 => x"3ec4" ,
	250 => x"3f0d" ,
	251 => x"3f4d" ,
	252 => x"3f83" ,
	253 => x"3fb0" ,
	254 => x"3fd2" ,
	255 => x"3feb" );
	
BEGIN
 PROCESS(H)
 BEGIN
	IF rising_edge(H) THEN
		IF Read = '1' THEN
				D	<= Contenu(conv_integer(A));
		ELSE
				D	<= "ZZZZZZZZZZZZZZZZ";
		END IF;
	END IF;
 END PROCESS; 
END comport; 
